from pyserver import *
import os
import datetime
import time
from virgotools import *
import PyTango


def get_data(devname, device, prefix):
    global log
    attrs = ""
    device.set_timeout_millis(40)

    #log.info("getting attributes values from device:%s", prefix)
    try:
        attribute_list=device.get_attribute_list()
    except:
         #log.warn("device %s not online, return empty sequence of attributes names/values", device)
         return attrs
    for attr in attribute_list:
        # strip away status and stragely formatted attributes
        if attr not in {'Status', 'CL_Level_Alarms_status',
        'CL_NonLevel_Alarms_status', 'PS_ControlState_status',
        'CL_ControlState_status', 'TTcal11_status', 'TTcal12_status',
        'TTcal13_status', 'MbValues', 'Gabbia'}:
            try:
                #log.info(attr)
                value = str(device[attr].value)
                if 'socketStatus' in attr:
                    i = 1
                    for status in device[attr].value:
                        attrs = attrs + " " + prefix + "PDU_SOCKET" + str(i) + " " + str(int(status))
                        i += 1
                elif attr == 'State':
                    state = str(int(device[attr].value))
                    #log.info("State index: %s", value)
                    clean_devname = devname.replace("/","") 
                    attrs = attrs + " " + prefix + clean_devname + "_" + attr + " " + state
                else:
                    attrs = attrs + " " + prefix + attr + " " + value
            except:
                 #log.warn("attribute %s non readable, not added on returned data", attr)
                continue
    return attrs

def get_devices_list():
    db = PyTango.Database()
    complete_list = []
    server = ""
    server = parse_key(cfg_path, 'TANGO_SERVER')
    if server:
        server = server[0][0] # single server
        complete_list = [dev for dev in db.get_device_class_list(server) if '/' in dev and not dev.startswith('dserver')] 
    else:  # not found, get the list of known servers 
        for server in db.get_server_list():
            #  strip away test and service servers
            if not any((match in server) for match in {"Based", "Hdb", "HDB", "test", "Archive", "Starter", "Access", "vtf", "MaxiGauge", "Midivac", "Eurotherm", "AdvMtr", "sdt", "cerre", "Lnfs"}): 
                #log.info("Reading from server %s:", server)
                list_of_devs = [dev for dev in db.get_device_class_list(server) if '/' in dev and not dev.startswith('dserver')]
                complete_list = complete_list + list_of_devs

    return complete_list

def get_proxy_dic(device_name_list):
    proxy_dic = {}
    prefix_dic = {}
    for devname in device_name_list: 
        proxy_dic.update({devname: PyTango.DeviceProxy(devname)})    
        property = PyTango.Database().get_device_property(devname,['name'])
        prefix = property['name'].__str__()[2:-2] 
        if not prefix == '':
            prefix = prefix + "_"
        prefix_dic.update({devname: prefix})

    return proxy_dic, prefix_dic 

